// CopyRight Philipos Sakellaropoulos 2001
// GeneralUtils.cpp : Implementation of CPathUtils
// CopyRight Philipos Sakellaropoulos 2001

#include "stdafx.h"
#include "MyInetUtils.h"
#include "PathUtils.h"

#include <shlwapi.h>

#define MY_MAX_PATH 2000
/////////////////////////////////////////////////////////////////////////////
// CPathUtils

STDMETHODIMP CPathUtils::InterfaceSupportsErrorInfo(REFIID riid)
{
	static const IID* arr[] = 
	{
		&IID_IPathUtils
	};
	for (int i=0; i < sizeof(arr) / sizeof(arr[0]); i++)
	{
		if (InlineIsEqualGUID(*arr[i],riid))
			return S_OK;
	}
	return S_FALSE;
}

STDMETHODIMP CPathUtils::PathRelativePathTo(BSTR From, VARIANT_BOOL IsFromFile, BSTR To, VARIANT_BOOL IsToFile,BSTR *Path)
{

	USES_CONVERSION;
  char szOut[MY_MAX_PATH] = "";
    
	BOOL ok = ::PathRelativePathTo(szOut,
     OLE2CT(From),IsFromFile ? FILE_ATTRIBUTE_NORMAL :FILE_ATTRIBUTE_DIRECTORY ,
     OLE2CT(To),IsToFile ? FILE_ATTRIBUTE_NORMAL :FILE_ATTRIBUTE_DIRECTORY);

	if(ok)	{
		CComBSTR strPath = szOut;
		//if(*Path != NULL) ::SysFreeString(*Path); 
		*Path = strPath.Detach();
	}
	return S_OK;
}

STDMETHODIMP CPathUtils::PathCanonicalize(BSTR Path, BSTR *Dest)
{
	USES_CONVERSION; 
  char szOut[MY_MAX_PATH] = ""; 

	BOOL ok = ::PathCanonicalize(szOut, OLE2CT(Path));
	if(ok)	{
		CComBSTR strPath = szOut;
		*Dest = strPath.Detach();
	}

	return S_OK;
}

STDMETHODIMP CPathUtils::PathFindFileName(BSTR Path, BSTR *Filename)
{
	USES_CONVERSION; 
  char szOut[MY_MAX_PATH] = ""; LPTSTR lpStr = NULL;

    if(::SysStringLen(Path)>0) 
		strcpy(szOut, OLE2CT(Path));
	lpStr = ::PathFindFileName(szOut);
	if(lpStr != NULL)	{
		CComBSTR strPath = lpStr;
		*Filename = strPath.Detach();
	}

	return S_OK;
}

STDMETHODIMP CPathUtils::GetShortPathName(BSTR Path,BSTR *ShortPath)
{
	USES_CONVERSION; 
  char *szOut= NULL; DWORD len = 0;

	szOut = new char [1000];
	len = ::GetShortPathName(OLE2CT(Path),szOut,1000);
	if(len > 0)	{
		CComBSTR strPath = szOut;
		*ShortPath = strPath.Detach();
	}
	delete [] szOut;
	return S_OK;
}

STDMETHODIMP CPathUtils::GetFullPathName(BSTR FileName, long *Pos, BSTR *FullFilename)
{
	USES_CONVERSION; 
  char *szOut= NULL; DWORD len = 0; LPTSTR lpFilePart; *Pos = 0;  

	szOut = new char [1000];
	len = ::GetFullPathName(OLE2CT(FileName),1000,szOut,&lpFilePart);
	if(len > 0)	{
		CComBSTR strPath = szOut;
		*FullFilename = strPath.Detach();
		*Pos = szOut - lpFilePart + 1;
	}
	delete [] szOut;
	return S_OK;
}

STDMETHODIMP CPathUtils::GetModuleFileName(BSTR *Filename)
{
	USES_CONVERSION; 
  char *szOut= NULL; DWORD len = 0;

	szOut = new char [1000];
	len = ::GetModuleFileName(NULL,szOut,1000);
	if(len > 0)	{
		CComBSTR strPath = szOut;
		*Filename = strPath.Detach();
	}
	delete [] szOut;
  
	return S_OK;
}


STDMETHODIMP CPathUtils::PathMatchSpec(BSTR FileParam, BSTR Spec, VARIANT_BOOL *Match)
{
	USES_CONVERSION; 

	BOOL bMatch = ::PathMatchSpec(OLE2CT(FileParam) ,OLE2CT(Spec) );
	if(bMatch)  *Match = VARIANT_TRUE;
	else        *Match = VARIANT_FALSE;

	return S_OK;
}

STDMETHODIMP CPathUtils::PathIsURL(BSTR Path, VARIANT_BOOL *IsURL)
{
	USES_CONVERSION; BOOL ok;

	ok = ::PathIsURL(OLE2CT(Path));
	if(ok) *IsURL = VARIANT_TRUE;
	else   *IsURL = VARIANT_FALSE;
	return S_OK;
}

STDMETHODIMP CPathUtils::PathQuoteSpaces(BSTR Path,BSTR *Out)
{
	USES_CONVERSION; TCHAR szOut[MY_MAX_PATH] = "";
	_tcscpy(szOut,OLE2CT(Path));
    
	::PathQuoteSpaces(szOut);
	*Out = CComBSTR(szOut).Detach(); 

	return S_OK;
}

STDMETHODIMP CPathUtils::PathCommonPrefix(BSTR File1, BSTR File2, BSTR *Path)
{

  USES_CONVERSION; 
  char szOut[MY_MAX_PATH] = ""; 
	
  int n = ::PathCommonPrefix(OLE2CT(File1),OLE2CT(File2),szOut);
  *Path = CComBSTR(szOut).Detach(); 
  return S_OK;
}



STDMETHODIMP CPathUtils::PathIsFileSpec(BSTR Path,VARIANT_BOOL *IsFileSpec)
{
	USES_CONVERSION; BOOL ok;

	ok = ::PathIsFileSpec(OLE2CT(Path));
	if(ok) *IsFileSpec = VARIANT_TRUE;
	else   *IsFileSpec = VARIANT_FALSE;

	return S_OK;
}

STDMETHODIMP CPathUtils::PathIsDirectory(BSTR Path, VARIANT_BOOL *IsDir)
{
	USES_CONVERSION; BOOL ok;

	ok = ::PathIsDirectory(OLE2CT(Path));
	if(ok) *IsDir = VARIANT_TRUE;
	else   *IsDir = VARIANT_FALSE;

	return S_OK;
}

STDMETHODIMP CPathUtils::PathIsPrefix(BSTR Prefix, BSTR Path, VARIANT_BOOL *IsPrefix)
{
	USES_CONVERSION; BOOL ok;

	ok = ::PathIsPrefix(OLE2CT(Prefix),OLE2CT(Path));
	if(ok) *IsPrefix = VARIANT_TRUE;
	else   *IsPrefix = VARIANT_FALSE;

	return S_OK;
}


STDMETHODIMP CPathUtils::PathIsRelative(BSTR Path, VARIANT_BOOL *IsRelative)
{
	USES_CONVERSION; BOOL ok;

	ok = ::PathIsRelative(OLE2CT(Path));
	if(ok) *IsRelative = VARIANT_TRUE;
	else   *IsRelative = VARIANT_FALSE;

	return S_OK;
}


STDMETHODIMP CPathUtils::PathIsRoot(BSTR Path, VARIANT_BOOL *IsRoot)
{
	USES_CONVERSION; BOOL ok;

	ok = ::PathIsRoot(OLE2CT(Path));
	if(ok) *IsRoot = VARIANT_TRUE;
	else   *IsRoot = VARIANT_FALSE;

	return S_OK;
}

STDMETHODIMP CPathUtils::PathIsSameRoot(BSTR Path1, BSTR Path2, VARIANT_BOOL *IsSameRoot)
{
	USES_CONVERSION; BOOL ok;

	ok = ::PathIsSameRoot(OLE2CT(Path1),OLE2CT(Path2));
	if(ok) *IsSameRoot = VARIANT_TRUE;
	else   *IsSameRoot = VARIANT_FALSE;

	return S_OK;
}

STDMETHODIMP CPathUtils::PathIsUNC(BSTR Path, VARIANT_BOOL *IsUNC)
{
	USES_CONVERSION; BOOL ok;

	ok = ::PathIsUNC(OLE2CT(Path));
	if(ok) *IsUNC = VARIANT_TRUE;
	else   *IsUNC = VARIANT_FALSE;

	return S_OK;
}

STDMETHODIMP CPathUtils::PathRemoveFileSpec(BSTR FullPath, BSTR *Path)
{
	USES_CONVERSION; 
    char szOut[MY_MAX_PATH] = ""; 

    if(::SysStringLen(FullPath)>0) 
	  strcpy(szOut, OLE2CT(FullPath));
	BOOL ok = ::PathRemoveFileSpec(szOut);
	if(ok)	*Path = CComBSTR(szOut).Detach();

	return S_OK;
}

STDMETHODIMP CPathUtils::PathRemoveArgs(BSTR Path, BSTR *Out)
{
	USES_CONVERSION; 
    char szOut[MY_MAX_PATH] = ""; 

    if(::SysStringLen(Path)>0) 
	   strcpy(szOut, OLE2CT(Path));
	::PathRemoveArgs(szOut);
	*Out = CComBSTR(szOut).Detach();

	return S_OK;
}


STDMETHODIMP CPathUtils::PathRemoveBackslash(BSTR Path, BSTR *Out)
{
	USES_CONVERSION; 
    char szOut[MY_MAX_PATH] = ""; 

    if(::SysStringLen(Path)>0) 
    	strcpy(szOut, OLE2CT(Path));
	::PathRemoveBackslash(szOut);
	*Out = CComBSTR(szOut).Detach();

	return S_OK;
}


STDMETHODIMP CPathUtils::PathRemoveBlanks(BSTR Path, BSTR *Out)
{
	USES_CONVERSION; 
    char szOut[MY_MAX_PATH] = ""; 

    if(::SysStringLen(Path)>0) 
	  strcpy(szOut, OLE2CT(Path));
	::PathRemoveBlanks(szOut);
	*Out = CComBSTR(szOut).Detach();

	return S_OK;
}

STDMETHODIMP CPathUtils::PathRemoveExtension(BSTR Path, BSTR *Out)
{
	USES_CONVERSION; 
    char szOut[MY_MAX_PATH] = ""; 

    if(::SysStringLen(Path)>0) 
	   strcpy(szOut, OLE2CT(Path));
	::PathRemoveExtension(szOut);
	*Out = CComBSTR(szOut).Detach();

	return S_OK;
}


STDMETHODIMP CPathUtils::PathRenameExtension(BSTR Path, BSTR Ext, BSTR *Out)
{
	USES_CONVERSION; 
    char szOut[MY_MAX_PATH] = ""; 

    if(::SysStringLen(Path)>0) 
	  strcpy(szOut, OLE2CT(Path));
	BOOL ok = ::PathRenameExtension(szOut,OLE2CT(Ext));
	if(ok)	*Out = CComBSTR(szOut).Detach();

	return S_OK;
}

STDMETHODIMP CPathUtils::UrlCombine(BSTR Base, BSTR Relative, BSTR *Combined)
{
  USES_CONVERSION; TCHAR pszCombined[3000]; DWORD dwCombined = 3000;
	
  HRESULT hr = ::InternetCombineUrl(OLE2CT(Base),OLE2CT(Relative),pszCombined,&dwCombined,ICU_DECODE ); 
  *Combined = CComBSTR(pszCombined).Detach(); 
  return S_OK;
}

STDMETHODIMP CPathUtils::PathCombine(BSTR Dir, BSTR File, BSTR *Dest)
{
    USES_CONVERSION;  TCHAR pszCombined[3000];

	::PathCombine(pszCombined,OLE2CT(Dir),OLE2CT(File));
	*Dest = CComBSTR(pszCombined).Detach(); 
	return S_OK;
}

STDMETHODIMP CPathUtils::MakeSureDirectoryPathExists(BSTR DirPath,VARIANT_BOOL *Success)
{
	USES_CONVERSION;

	BOOL ok = ::MakeSureDirectoryPathExists(OLE2CT(DirPath));
	if(ok) *Success = VARIANT_TRUE;
	else   *Success = VARIANT_FALSE;

	return S_OK;
}

/* // not defined in any library
STDMETHODIMP CPathUtils::IsPathHTMLFile(BSTR File,VARIANT_BOOL *IsHTML)
{
	USES_CONVERSION; BOOL bIsHTML = TRUE;

	//bIsHTML = ::PathIsHTMLFile(OLE2CT(File) );
	if(bIsHTML)  *IsHTML = VARIANT_TRUE;
	else         *IsHTML = VARIANT_FALSE;

	return S_OK;
}

STDMETHODIMP CPathUtils::PathCreateFromUrl(BSTR URL, BSTR *Path)
{
	USES_CONVERSION; HRESULT ok;
  char szOut[MY_MAX_PATH] = ""; 
	DWORD nPath;


	//ok = ::PathCreateFromUrl(OLE2CT(URL),szOut,&nPath,NULL);
	if(SUCCEEDED(ok))	{
		CComBSTR strPath = szOut;
		*Path = CComBSTR(szOut).Detach();
	}
	return S_OK;
}


STDMETHODIMP CPathUtils::UrlCreateFromPath(BSTR Path, BSTR *Url)
{
	USES_CONVERSION; HRESULT ok;
  char szOut[MY_MAX_PATH] = ""; 
	DWORD nPath;

//	ok = ::UrlCreateFromPath(OLE2CT(Path),szOut,&nPath,NULL);
	if(SUCCEEDED(ok))	
		*Url = CComBSTR(szOut).Detach();
	return S_OK;
}
*/

