// (C) Philip Sakellaropoulos 2001
// GeneralUtils.h : Declaration of the CPathUtils

#ifndef __PATHUTILS_H_
#define __PATHUTILS_H_

#include "resource.h"       // main symbols

/////////////////////////////////////////////////////////////////////////////
// CPathUtils
class ATL_NO_VTABLE CPathUtils : 
	public CComObjectRootEx<CComSingleThreadModel>,
	public CComCoClass<CPathUtils, &CLSID_PathUtils>,
	public ISupportErrorInfo,
	public IDispatchImpl<IPathUtils, &IID_IPathUtils, &LIBID_MYINETUTILSLib>
{
public:
	CPathUtils()
	{
	}

DECLARE_REGISTRY_RESOURCEID(IDR_PATHUTILS)

DECLARE_PROTECT_FINAL_CONSTRUCT()

BEGIN_COM_MAP(CPathUtils)
	COM_INTERFACE_ENTRY(IPathUtils)
	COM_INTERFACE_ENTRY(IDispatch)
	COM_INTERFACE_ENTRY(ISupportErrorInfo)
END_COM_MAP()

// ISupportsErrorInfo
	STDMETHOD(InterfaceSupportsErrorInfo)(REFIID riid);

// IPathUtils
public:
	STDMETHOD(MakeSureDirectoryPathExists)(/*[in]*/ BSTR DirPath,VARIANT_BOOL *Success);
	STDMETHOD(UrlCombine)(/*[in]*/ BSTR Base,/*[in]*/ BSTR Relative,/*[out,retval]*/ BSTR *Combined);
	STDMETHOD(PathRenameExtension)(/*[in]*/ BSTR Path,/*[in]*/ BSTR Ext,/*[out,retval]*/ BSTR *Out);
	STDMETHOD(PathRemoveExtension)(/*[in]*/ BSTR Path,/*[out,retval]*/ BSTR *Out);
	STDMETHOD(PathRemoveBlanks)(/*[in]*/ BSTR Path,/*[out,retval]*/ BSTR *Out);
	STDMETHOD(PathRemoveBackslash)(/*[in]*/ BSTR Path,/*[out,retval]*/ BSTR *Out);
	STDMETHOD(PathRemoveArgs)(/*[in]*/ BSTR Path,/*[out,retval]*/ BSTR *Out);
	STDMETHOD(PathIsUNC)(/*[in]*/ BSTR Path,/*[out,retval]*/ VARIANT_BOOL *IsUNC);
	STDMETHOD(PathIsSameRoot)(/*[in]*/ BSTR Path1,/*[in]*/ BSTR Path2,/*[out,retval]*/ VARIANT_BOOL *IsSameRoot);
	STDMETHOD(PathIsRoot)(/*[in]*/ BSTR Path,/*[out,retval]*/ VARIANT_BOOL *IsRoot);
	STDMETHOD(PathIsRelative)(/*[in]*/ BSTR Path,/*[out,retval]*/ VARIANT_BOOL *IsRelative);
	STDMETHOD(PathIsPrefix)(/*[in]*/ BSTR Prefix,/*[in]*/ BSTR Path,/*[out,retval]*/ VARIANT_BOOL *IsPrefix);
	STDMETHOD(PathIsDirectory)(/*[in]*/ BSTR Path,/*[out,retval]*/ VARIANT_BOOL *IsDir);
	STDMETHOD(PathIsFileSpec)(/*[in]*/ BSTR Path,/*[out,retval]*/ VARIANT_BOOL *IsFileSpec);
	STDMETHOD(PathCommonPrefix)(/*[in]*/ BSTR File1,/*[in]*/ BSTR File2,/*[out,retval]*/ BSTR *Path);
	STDMETHOD(PathQuoteSpaces)(/*[in]*/ BSTR Path,/*[out,retval]*/BSTR *Out);
	STDMETHOD(PathIsURL)(/*[in]*/ BSTR Path,/*[out,retval]*/ VARIANT_BOOL *IsURL);
	//STDMETHOD(IsPathHTMLFile)(/*[in]*/BSTR File,/*[out,retval]*/ VARIANT_BOOL *IsHTML);
	STDMETHOD(PathMatchSpec)(/*[in]*/ BSTR FileParam,/*[in]*/ BSTR Spec,/*[out,retval]*/ VARIANT_BOOL *Match);
	//STDMETHOD(UrlCreateFromPath)(/*[in]*/ BSTR Path,/*[out,retval]*/ BSTR *Url);
	STDMETHOD(GetFullPathName)(/*[in]*/ BSTR FileName,/*[out]*/ long *Pos,/*[out,retval]*/ BSTR *FullFilename);
	STDMETHOD(GetModuleFileName)(/*[out,retval]*/ BSTR *Filename);
	STDMETHOD(PathRemoveFileSpec)(/*[in]*/ BSTR FullPath,/*[out,retval]*/ BSTR *Path);
	STDMETHOD(GetShortPathName)(/*[in]*/ BSTR Path,BSTR *ShortPath);
	//STDMETHOD(PathCreateFromUrl)(/*[in]*/ BSTR URL,/*[out,retval]*/ BSTR *Path);
	STDMETHOD(PathFindFileName)(/*[in]*/ BSTR Path,/*[out,retval]*/ BSTR *Filename);
	STDMETHOD(PathCanonicalize)(/*[in]*/ BSTR Path,/*[out,retval]*/ BSTR *Dest);
	STDMETHOD(PathCombine)(/*[in]*/ BSTR Dir,/*[in]*/ BSTR File,BSTR *FullPath);
	STDMETHOD(PathRelativePathTo)(/*[in]*/ BSTR From,/*[in]*/ VARIANT_BOOL IsFromFile,/*[in]*/ BSTR To,/*[in]*/ VARIANT_BOOL IsToFile,BSTR *Path);
};

#endif //__PATHUTILS_H_
